<?php
/*
#libphp/magic_quotes_off.inc
#created by Olivier Langella 19/8/2004
#
#DESC
# see if the PHP environment is set with magic_quotes ON
# if so: it stripslashes from the $_POST array
# it is necessary to get rid of problems with other PHP environment and to use other functions (database functions)
# the same way if the data are provided by a file, or by a form in PHP
#
#INPUT
#
#OUTPUT
# 
#
#VALIDATED
#VDATE
#
#AUTHORS
# Olivier Langella <olivier.langella@moulon.inra.fr> 
*/

function stripslashes_array(& $array) {
	while (list ($key) = each($array)) {
		if (is_array($array[$key])) {
			stripslashes_array($array[$key]);
		} else {
			$array[$key] = stripslashes($array[$key]);
		}
	}
}

if (get_magic_quotes_gpc()) {
	stripslashes_array($_POST);
}

?>